/*******************************************************************************
 * Copyright (c) 2005 IBM Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.stp.core.delete.operations;

import org.eclipse.stp.core.infrastructure.operations.IAbstractScribblerDataModelProperties;

public interface IDeleteServiceDataModelProperties extends
      IAbstractScribblerDataModelProperties {
   /**
    * [REQUIRED] ComponentType who owns the services which are to be deleted.
    * 
    * Type = {@link org.eclipse.stp.core.sca.ComponentType}
    */
   public static final String COMPONENT_TYPE = "IDeleteInterfaceDataModelProperties.COMPONENT_TYPE"; //$NON-NLS-1$

   /**
    * [REQUIRED] Array of services names that needs to be deleted.
    * 
    * 
    * Type = {@link java.lang.String []}
    */
   public static final String SERVICE_NAMES  = "IDeleteInterfaceDataModelProperties.SERVICE_NAMES"; //$NON-NLS-1$	
}
